#!/usr/bin/env python

import gtk
import gobject
import bluetooth
import os
import time

try:
    import gnome.gconf as gconf
except ImportError:
    import gconf

try:
    import hildon
except ImportError:
    hildon = None

class MGSetup():
    cgclnt = None
    iconupdate = 3000
    invokedfrom = 0
    __gcpath = '/apps/maemo/minigpsd'

    #exported
    button = None
    menu = None

    def setup(self,cfrom):

        self.invokedfrom = cfrom
        self.button = gtk.Button()
        self.button.set_image(gtk.image_new_from_stock(gtk.STOCK_YES, gtk.ICON_SIZE_MENU))
        self.button.set_name("menu")
        if self.invokedfrom == 1:
            self.button.set_size_request(40,40)
        elif self.invokedfrom == 2:
            self.button.set_size_request(64,64)
	    gtk.Widget.set_name( self.button, "hildon-navigator-button-one" )
        else:
            self.button.set_size_request(320,320)
        self.__create_menu()
        if self.invokedfrom != 3: ###
            self.button.connect("clicked",self.__popup_menu)
        self.button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(24000,24000,24000))
        self.button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.Color(32000,32000,32000))
        self.button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.Color(40000,40000,40000))
        self.button.show()
        gobject.timeout_add(500,self.__timeout)

        self.cgclnt = gconf.client_get_default()
        self.__setgconf( "inactivity", "0" )
        val = self.__getgconf( "ICONUPDATE" )
        if not val:
            val = 3
        self.iconupdate = int(val)

        self.cgclnt.add_dir( self.__gcpath , gconf.CLIENT_PRELOAD_NONE)
        self.cgclnt.notify_add( self.__gcpath + '/inactivity' , self.inactive)

        if not cfrom:
            pass
        #dbus, osso experiments go here, from setup, then add routnes
        os.system( "/usr/bin/dbus2gconf.py &" )
        return self.button

    active = 1;
    def inactive(self, client, *args, **kwargs):
        val = self.__getgconf( "inactivity" )
        if val and val == "1":
            self.active = 0
        else:
            if self.active == 0:
                gobject.timeout_add(100,self.__timeout)
            self.active = 1

    warningxpm = [
    "40 40 4 1",
    ". c None",
    "a c #404040",
    "b c #808080",
    "# c #000000",
    "...............##########...............",
    "............################............",
    "..........######aaaabbbb######..........",
    ".........####aaaaaaabbbbbbb####.........",
    ".......####aaaaaaaaabbbbbbbbb####.......",
    "......###aaaaaaaaaaabbbbbbbbbbb###......",
    ".....###aaaaaaaaaaaabbbbbbbbbbbb###.....",
    "....###aaaaaaaaaaaaabbbbbbbbbbbbb###....",
    "....##aaaaaaaaaabbbbaaaabbbbbbbbbb##....",
    "...##aaaaaaaaabbbbbbaaaaaabbbbbbbbb##...",
    "..###aaaaaaaabbbbbbbaaaaaaabbbbbbbb###..",
    "..##aaaaaaaabbbbbbbbaaaaaaaabbbbbbbb##..",
    ".###aaaaaaabbbbbbbbbaaaaaaaaabbbbbbb###.",
    ".##aaaaaaabbbbbbbbbbaaaaaaaaaabbbbbbb##.",
    ".##aaaaaabbbbbbbbbaabbaaaaaaaaabbbbbb##.",
    "###aaaaaabbbbbbbaaaabbbbaaaaaaabbbbbb###",
    "##aaaaaabbbbbbbaaaaabbbbbaaaaaaabbbbbb##",
    "##aaaaaabbbbbbbaaaaabbbbbaaaaaaabbbbbb##",
    "##aaaaaabbbbbbaaaaaabbbbbbaaaaaabbbbbb##",
    "##aaaaaabbbbbbaaaaaabbbbbbaaaaaabbbbbb##",
    "##bbbbbbaaaaaabbbbbbaaaaaabbbbbbaaaaaa##",
    "##bbbbbbaaaaaabbbbbbaaaaaabbbbbbaaaaaa##",
    "##bbbbbbaaaaaaabbbbbaaaaabbbbbbbaaaaaa##",
    "##bbbbbbaaaaaaabbbbbaaaaabbbbbbbaaaaaa##",
    "###bbbbbbaaaaaaabbbbaaaabbbbbbbaaaaaa###",
    ".##bbbbbbaaaaaaaaabbaabbbbbbbbbaaaaaa##.",
    ".##bbbbbbbaaaaaaaaaabbbbbbbbbbaaaaaaa##.",
    ".###bbbbbbbaaaaaaaaabbbbbbbbbaaaaaaa###.",
    "..##bbbbbbbbaaaaaaaabbbbbbbbaaaaaaaa##..",
    "..###bbbbbbbbaaaaaaabbbbbbbaaaaaaaa###..",
    "...##bbbbbbbbbaaaaaabbbbbbaaaaaaaaa##...",
    "....##bbbbbbbbbbaaaabbbbaaaaaaaaaa##....",
    "....###bbbbbbbbbbbbbaaaaaaaaaaaaa###....",
    ".....###bbbbbbbbbbbbaaaaaaaaaaaa###.....",
    "......###bbbbbbbbbbbaaaaaaaaaaa###......",
    ".......####bbbbbbbbbaaaaaaaaa####.......",
    ".........####bbbbbbbaaaaaaa####.........",
    "..........######bbbbaaaa######..........",
    "............################............",
    "...............##########..............."
    ]

    def __timeout(self):
        try:
            pixbuf = gtk.gdk.pixbuf_new_from_file( "/tmp/gps.xpm")
            #            pixbuf = gtk.gdk.pixbuf_new_from_file_at_size( "/tmp/gps.xpm", 360, 360)
        except gobject.GError:
            pixbuf = gtk.gdk.pixbuf_new_from_xpm_data(self.warningxpm)
        image = gtk.Image()
	if self.invokedfrom > 0:
            image.set_from_pixbuf(pixbuf)
        else:
            w = self.button.get_allocation().width
            h = self.button.get_allocation().height
            if w > h:
                w = h
            image.set_from_pixbuf(pixbuf.scale_simple(w,w,gtk.gdk.INTERP_NEAREST))
        self.button.set_image(image)
        if self.active:
            gobject.timeout_add(self.iconupdate * 1000,self.__timeout)
#testing
        else:
            self.button.set_image(gtk.image_new_from_stock(gtk.STOCK_YES, gtk.ICON_SIZE_MENU))


    act_menu_item = None
    def __create_menu(self):
        self.menu = gtk.Menu()
#ImageMenuItem to get right theme for taskbar
        self.act_menu_item = gtk.ImageMenuItem("GPSD Active")
        self.act_menu_item.connect('activate',self.__togglegpsd)
        self.menu.append(self.act_menu_item)

        menu_item = gtk.ImageMenuItem("Configure...")
        self.menu.append(menu_item)

	if self.invokedfrom == 2:
	    gtk.Widget.set_name( self.menu, "menu_from_navigator" )
            gtk.Widget.set_size_request( self.act_menu_item, 240,64 )
            gtk.Widget.set_size_request( menu_item, 240,64 )

        menu_item.connect('activate',self.__gpsddialog)
        self.menu.show_all()

    def __popup_menu(self,widget,data=None):
        t = self.act_menu_item.get_children()[0]
        if os.path.exists("/tmp/minigpsd.pid"):
            t.set_label("Stop GPSD")
        else:
            t.set_label("Start GPSD")
        self.menu.popup(None,None,self.__menu_position,0,gtk.get_current_event_time())

    def __menu_position(self,data=None):
        if self.invokedfrom == 2:
            x = self.button.get_allocation().x + self.button.get_allocation().width
            y = self.button.get_allocation().y
            return (x,y,True)
        (reqw, reqh) = self.menu.get_size_request()
        sw = self.button.get_screen().get_width()
        (x,y) = self.button.get_parent_window().get_position()
        if self.invokedfrom == 1:
            y = y + self.button.get_allocation().y + self.button.get_allocation().height
            x = x + self.button.get_allocation().x
        greater = x + reqw
        if greater > sw:
            x = x - req.width - self.button.get_allocation().width;
        return (x,y,True)

    def __togglegpsd(self,widget,data=None):
        if os.path.exists("/tmp/minigpsd.pid"):
            os.system( "killall minigpsd" )
        else:
            os.system( "/usr/bin/minigpsd &" )

    def __setgconf(self, key, val):
        self.cgclnt.set_string(self.__gcpath + "/" + key, val )

    def __getgconf(self, key):
        return self.cgclnt.get_string(self.__gcpath + "/" + key)

    def __gpsddialog(self, widget):
        dialog = gtk.MessageDialog( None,
            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
            gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, None)

        dialog.set_markup("Configure MiniGPSD operation")

        lwid = 12
        if os.path.exists("/var/lib/gps/gps_driver_ctrl"):
            hbox = gtk.HBox(False, 0 )
            dialog.vbox.pack_start(hbox, True,True, 0)
            label = gtk.Label("Internal GPS");
            hbox.pack_start(label, False , True, 0)
            label.set_width_chars(lwid);
            internal = gtk.CheckButton("Use n810");
            t = self.__getgconf( "GPSI" )
            if t == "Internal":
                internal.set_active(1);
            hbox.pack_start(internal, True , True, 0)



        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("BT set dev to /dev/rfcommN N=0..9");
        hbox.pack_start(label, False , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("External GPS");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)

        gpsenable = gtk.CheckButton("On");
        t = self.__getgconf( "USEGPS" )
        if t == "1":
            gpsenable.set_active(1);
        hbox.pack_start(gpsenable, True , True, 0)

        label = gtk.Label("Device:");
        hbox.pack_start(label, False , True, 0)

        externdev = gtk.Entry()
        externdev.set_max_length(30)
        externdev.set_width_chars(15)
        t = self.__getgconf( "GPSdev" )
        if not t:
            t = "/dev/rfcomm0"
        externdev.set_text(t)
        hbox.pack_start(externdev, False, True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("New KML Every");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "KMLINTERVAL" )
        if not val:
            val = 5
        adj = gtk.Adjustment(float(val), 0, 60*24, 1, 30, 0)
        kmlrate = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(kmlrate, False , False, 0)
        label = gtk.Label("Min. 0-nolog ");
        hbox.pack_start(label, False , False, 0)

        button = gtk.Button()
        button.set_label("to Folder...")
        button.connect("clicked",self.__kmldir)
        hbox.pack_start(button, True,True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Web Title");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)
        webtitle = gtk.Entry()
        webtitle.set_max_length(80)
        webtitle.set_width_chars(32)
        t = self.__getgconf( "MYNAME" )
        if not t:
            t = "MiniGPSD"
        webtitle.set_text(t)
        hbox.pack_start(webtitle, False , True, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)

        button = gtk.Button()
        button.set_label("GPSGate...")
        button.connect("clicked",self.__gatedialog)
        hbox.pack_start(button, True,False, 0)

        button = gtk.Button()
        button.set_label("Advanced...")
        button.connect("clicked",self.__advanced)
        hbox.pack_start(button, True,False, 0)


        button = gtk.Button()
        button.set_label("BT Scan...")
        button.connect("clicked",self.__btscan)
        hbox.pack_start(button, True,False, 0)


        dialog.show_all()
        t = dialog.run()
        if t == gtk.RESPONSE_OK:
            val = kmlrate.get_value_as_int()
            if not os.path.exists("/var/lib/gps/gps_driver_ctrl"):
                self.__setgconf( "GPSI", "OFF" )
            elif internal.get_active():
                self.__setgconf( "GPSI", "Internal" );
            else:
                self.__setgconf( "GPSI", "OFF" )
            if gpsenable.get_active():
                self.__setgconf( "USEGPS", "1" );
            else:
                self.__setgconf( "USEGPS", "0" );
            self.__setgconf( "KMLINTERVAL", str(val) )
            self.__setgconf( "MYNAME", webtitle.get_text() )
            self.__setgconf( "GPSdev", externdev.get_text() )

        dialog.destroy()


    __btcomblist = None
    __gpsaddr = None
    __obdaddr = None

    def __btsetgps(self,widget):
        ml = self.__btcomblist.get_model()
        ix = self.__btcomblist.get_active()
        t = ml[ix][0][0:17]
        self.__gpsaddr.set_text(t)
        self.__setgconf( "GPSaddr", t )

    def __btsetobd(self,widget):
        ml = self.__btcomblist.get_model()
        ix = self.__btcomblist.get_active()
        t = ml[ix][0][0:17]
        self.__obdaddr.set_text(t)
        self.__setgconf( "OBDaddr", t )

    __btstat = None
    def __btdoscan(self):
        try:
            btlist = bluetooth.discover_devices(lookup_names=True)
        except bluetooth.BluetoothError:
            btlist = None

        if btlist:
            for addr,name in btlist:
                self.__btcomblist.append_text(addr+"   |   "+name)

        self.__btstat.set_text("Bluetooth Device Selections:");


    def __btscan(self,widget):
        dialog = gtk.MessageDialog( None,
            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
            gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK, None)

        dialog.set_markup("Bluetooth Scan and Set")

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Please pair and set trusted in")
        hbox.pack_start(label, False , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("location manager or bluetooth settings first")
        hbox.pack_start(label, False , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        self.__btstat = gtk.Label("Bluetooth Device List: (*SEARCHING*)");
        hbox.pack_start(self.__btstat, False , True, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)


        self.__btcomblist = gtk.combo_box_new_text()
        t1 = self.__getgconf( "GPSaddr" )
        if t1:
    	    t = t1 + "   |   Current GPS Saved"
        else:
            t = "00:00:00:00:00:00   |   No GPS Set"
        self.__btcomblist.append_text(t)

        try:
            f = open("/var/lib/gps/gps_BT_devices","r")
            t1 = f.readline()
            t = t1[0:17] + "   |   Location Manager"
            f.close()
            self.__btcomblist.append_text(t)
        except IOError:
            pass

        t1 = self.__getgconf( "OBDaddr" )
        if t1:
            t = t1 + "   |   Current OBD Saved"
        else:
            t = "00:00:00:00:00:00   |   No OBD Set"
        self.__btcomblist.append_text(t)
        self.__btcomblist.set_active(0)
        hbox.pack_start(self.__btcomblist, False, True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)


        l1 = gtk.Label("GPS BT Addr:");
        hbox.pack_start(l1, False , True, 0)


        self.__gpsaddr = gtk.Entry()
        self.__gpsaddr.set_max_length(17)
        self.__gpsaddr.set_width_chars(17)
        t = self.__getgconf( "GPSaddr" )
        if not t:
            t = "00:00:00:00:00:00"
        self.__gpsaddr.set_text(t)
        hbox.pack_start(self.__gpsaddr , True,False, 0)

        button = gtk.Button()
        button.set_label("Set GPS")
        button.connect("clicked",self.__btsetgps)
        hbox.pack_start(button, True,False, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)

        l1 = gtk.Label("OBD BT Addr:");
        hbox.pack_start(l1, False , True, 0)


        self.__obdaddr = gtk.Entry()
        self.__obdaddr.set_max_length(17)
        self.__obdaddr.set_width_chars(17)
        t = self.__getgconf( "OBDaddr" )
        if not t:
            t = "00:00:00:00:00:00"
        self.__obdaddr.set_text(t)

        hbox.pack_start(self.__obdaddr , True,False, 0)

        button = gtk.Button()
        button.set_label("Set OBD")
        button.connect("clicked",self.__btsetobd)
        hbox.pack_start(button, True,False, 0)

        dialog.show_all()
        gobject.timeout_add(500,self.__btdoscan)
        t = dialog.run()
        dialog.destroy()


    def __kmldir(self,widget):
        if False and hildon:
            fcd = hildon.FileChooserDialog(widget.get_parent_window(),#window,
                        gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        else:
            fcd = gtk.FileChooserDialog("Select Directory for KMZ",
                                    None,
                                    gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
                                    (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                     gtk.STOCK_OPEN, gtk.RESPONSE_OK))

        fcd.set_default_response(gtk.RESPONSE_OK)
        t = self.__getgconf( "LOGDIR" )
        if t:
            fcd.set_current_folder(t)
        response = fcd.run()
        if response == gtk.RESPONSE_OK:
            self.__setgconf( "LOGDIR", fcd.get_filename() )
        fcd.destroy()

    def __advanced(self,widget):
        dialog = gtk.MessageDialog( None,
            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
            gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, None)

        dialog.set_markup("Advanced GPS Setup")

        lwid = 10


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("BT set dev to /dev/rfcommN N=0..9");
        hbox.pack_start(label, False , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("OBD");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)

        obdenable = gtk.CheckButton("On");
        t = self.__getgconf( "USEOBD" )
        if t == "1":
            obdenable.set_active(1);
        hbox.pack_start(obdenable, True , True, 0)


        label = gtk.Label("Device:");
        hbox.pack_start(label, False , True, 0)

        obddev = gtk.Entry()
        obddev.set_max_length(30)
        obddev.set_width_chars(15)
        t = self.__getgconf( "OBDdev" )
        if not t:
            t = "/dev/rfcomm1"
        obddev.set_text(t)
        hbox.pack_start(obddev, False, True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("http port");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "HTTPPORT" )
        if not val:
            val = 8888
        adj = gtk.Adjustment(float(val), 1, 65535, 1, 256, 0)
        httpval = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(httpval, False , False, 0)

        sep = gtk.HSeparator()
        hbox.pack_start(sep, True, False, 0)

        label = gtk.Label("gpsd port");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "GPSDPORT" )
        if not val:
            val = 2947
        adj = gtk.Adjustment(float(val), 1, 65535, 1, 256, 0)
        gpsdval = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(gpsdval, False , False, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("obd direct");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "OBDTHRU" )
        if not val:
            val = 22534
        adj = gtk.Adjustment(float(val), 1, 65535, 1, 256, 0)
        obdt = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(obdt, False , False, 0)

        sep = gtk.HSeparator()
        hbox.pack_start(sep, True, False, 0)

        label = gtk.Label("gps direct");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "GPSTHRU" )
        if not val:
            val = 22947
        adj = gtk.Adjustment(float(val), 1, 65535, 1, 256, 0)
        gpst = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(gpst, False , False, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("icon rate");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , False, 0)
        val = self.__getgconf( "ICONUPDATE" )
        if not val:
            val = 3
        adj = gtk.Adjustment(float(val), 1, 3600, 1, 60, 0)
        iconu = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(iconu, False , False, 0)

        label = gtk.Label("secs");
        label.set_width_chars(4);
        hbox.pack_start(label, False , False, 0)

        sep = gtk.HSeparator()
        hbox.pack_start(sep, True, False, 0)

        #UNIXSOCK "/tmp/.gpsd_ctrl_sock"
        #ZIPKML "/usr/bin/kml2kmz"

        dialog.show_all()
        t = dialog.run()

        if t == gtk.RESPONSE_OK:
            val = httpval.get_value_as_int()
            self.__setgconf( "HTTPPORT", str(val) )
            val = gpsdval.get_value_as_int()
            self.__setgconf( "GPSDPORT", str(val) )
            val = obdt.get_value_as_int()
            self.__setgconf( "OBDTHRU", str(val) )
            val = gpst.get_value_as_int()
            self.__setgconf( "GPSTHRU", str(val) )

            val = iconu.get_value_as_int()
            self.__setgconf( "ICONUPDATE", str(val) )
            iconupdate = int(val)

            if obdenable.get_active():
                self.__setgconf( "USEOBD", "1" );
            else:
                self.__setgconf( "USEOBD", "0" );

            self.__setgconf( "OBDdev", obddev.get_text() )

        dialog.destroy()


    def __gatedialog(self,widget):
        dialog = gtk.MessageDialog( None,
            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
            gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, None)

        dialog.set_markup("Configure GPSGate")

        lwid = 8

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Enable");
        hbox.pack_start(label, False , True, 0)
        label.set_width_chars(lwid);
        t = self.__getgconf( "UseGPSGate" )
        internal = gtk.CheckButton("Enable");
        if t == "1":
            internal.set_active(1);
        hbox.pack_start(internal, True , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Proto");
        hbox.pack_start(label, False , True, 0)
        label.set_width_chars(lwid);
        t = self.__getgconf( "GPSGATEtcp" )
        proto = gtk.CheckButton("Use TCP instead of UDP");
        if t == "1":
            proto.set_active(1);
        hbox.pack_start(proto, True , True, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Host");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)
        gpsgate = gtk.Entry()
        gpsgate.set_max_length(50)
        gpsgate.set_width_chars(36)
        t = self.__getgconf( "GPSGATEhost" )
        if not t:
            t = "online.gpsgate.com"
        gpsgate.set_text(t)
        hbox.pack_start(gpsgate, False , True, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Port");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)

        t = self.__getgconf( "GPSGATEport" )
        val = 30175
        if t:
            val = int(t)
        adj = gtk.Adjustment(float(val), 1, 65535, 1, 256, 0)
        ggport = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(ggport, False , False, 0)

        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("IMEI");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)
        imei = gtk.Entry()
        imei.set_max_length(50)
        imei.set_width_chars(20)
        t = self.__getgconf( "GPSGATEimei" )
        if not t:
            t = "(enter imei)"
        imei.set_text(t)
        hbox.pack_start(imei, False , True, 0)


        hbox = gtk.HBox(False, 0 )
        dialog.vbox.pack_start(hbox, True,True, 0)
        label = gtk.Label("Rate");
        label.set_width_chars(lwid);
        hbox.pack_start(label, False , True, 0)

        t = self.__getgconf( "GPSGATErate" )
        val = 5
        if t:
            val = int(t)
        adj = gtk.Adjustment(float(val), 1, 3600, 1, 60, 0)
        ggrate = gtk.SpinButton(adj, 0.0, 0)
        hbox.pack_start(ggrate, False , False, 0)

        dialog.show_all()
        t = dialog.run()
        if t == gtk.RESPONSE_OK:
            self.__setgconf( "GPSGATEhost", gpsgate.get_text() )
            val = ggport.get_value_as_int()
            self.__setgconf( "GPSGATEport", str(val) )
            val = ggrate.get_value_as_int()
            self.__setgconf( "GPSGATErate", str(val) )
            self.__setgconf( "GPSGATEimei", imei.get_text() )
            if internal.get_active():
                self.__setgconf( "UseGPSGate", "1" )
            else:
                self.__setgconf( "UseGPSGate", "0" )
            if proto.get_active():
                self.__setgconf( "GPSGATEtcp", "1" )
            else:
                self.__setgconf( "GPSGATEtcp", "0" )

        dialog.destroy()
    
